
open "funsig_h"
open "gclauses_h"
open "clauses_h"

datatype transformer =
	 T_INLINE of string (* inline predicates matching this regexp *)
       | T_MAGIC (* defined respectively to current set of goals *)
       | T_PARTITION of string * string (* partition states;
					 first string is regexp for states,
					 second is regexp for sorts to partition. *)
	 ;

type precedence = string list; (* to specify an ordering: list of regexps,
				first matching regexp gives precedence:
				the earlier the higher the precedence. *)
extern val order_of_prec : precedence -> (string * string -> bool);

extern val print_transformer : 'a outstream -> transformer -> unit;

extern val engine : funsig * program * goal list * transformer list *
	   (string * string -> bool) * bool
	   -> (string, string) tableau;

