
open "rel_h";

fun addrel ((x,ys),r) =
    if x inset r
        then r ++ {x => ?r x U ys}
    else r ++ {x => ys};

fun invrel ({} : ''a -m> ''b) : ''b -m> ''a set = {}
  | invrel {x => y} = {y => {x}}
  | invrel m = let val (m1, m2) = split m
		   val im1 = invrel m1
		   val im2 = invrel m2
	       in
		   (im1 delta im2) ++ {y => xs1 U xs2
				      | y => xs2 in map im1 <| im2
					val xs1 = ?im1 y}
	       end;

fun inv_rel {} = {}
  | inv_rel {x => ys} = {y => {x} | y in set ys}
  | inv_rel m = let val (m1, m2) = split m
		    val im1 = inv_rel m1
		    val im2 = inv_rel m2
		in
		    (im1 delta im2) ++ {y => xs1 U xs2
				       | y => xs2 in map im1 <| im2
					   val xs1 = ?im1 y}
		end;

fun m1 Urel m2 =
    (m1 delta m2) ++ {x => ys1 U ys2
		     | x => ys2 in map m1 <| m2
			 val ys1 = ?m1 x};

fun union_rel {} = {}
  | union_rel {r} = r
  | union_rel rs = let val (rs1, rs2) = split rs
		   in
		       union_rel rs1 Urel union_rel rs2
		   end;

fun comp_rel (r1, r2) = {x => zs
			| x => ys in map r2
			  val zs = union (rng (ys <| r1))
			      such that not (empty zs)};

fun transitive_closure r =
    let val r' = comp_rel (r, r) Urel r
    in
	if r=r'
	    then r
	else transitive_closure r'
    end;
