(* sorting functions *)

fun merge less =
    let fun merge ([],l2) = l2
	  | merge (l1,[]) = l1
	  | merge (l1 as x1::l'1,l2 as x2::l'2) =
	    if less(x1,x2)
		then x1::merge(l'1,l2)
	    else x2::merge(l1,l'2)
    in
	merge
    end

fun sort less = (* (''a * ''a -> bool) -> (''a -m> 'b) -> ''a list *)
    let val merge = merge less
	fun sort {} = []
	  | sort {x => _} = [x]
	  | sort vars =
	    let val (vars1,vars2) = split vars
	    in
		merge (sort vars1,sort vars2)
	    end
    in
	sort
    end

fun least less =
    let fun find {} = raise Empty
	  | find {x => _} = x
	  | find xs = let val (xs1,xs2) = split xs
			  val x1 = find xs1
			  val x2 = find xs2
		      in
			  if less (x1,x2)
			      then x1
			  else x2
		      end
    in
	find
    end
