
{
open Evaparse

}

let letter = ['A'-'Z' 'a'-'z']
let alpha = ['A'-'Z' 'a'-'z' '0'-'9' '_']
let id = '_'* letter alpha*
rule token = parse
  [' ' '\t' '\n' '\r']+ { token lexbuf }
| ['0'-'9']+           { INT (int_of_string (Lexing.lexeme lexbuf)) }
| '('                  { KW_LPAREN }
| ')'                  { KW_RPAREN }
| '<'                  { KW_LANGLE }
| '>'                  { KW_RANGLE }
| '{'                  { KW_LBRACE }
| '}'                  { KW_RBRACE }
| '_'                  { KW_SUB }
| '^'                  { KW_SUP }
| "case"               { KW_CASE }
| "hash"               { KW_HASH }
| "alias"              { KW_ALIAS }
| "axiom"              { KW_AXIOM }
| "knows"              { KW_KNOWS }
| "intruder"           { KW_INTRUDER }
| "session"            { KW_SESSION }
| "switch"             { KW_SWITCH }
| '%'                  { KW_PERCENT }
| ':'                  { KW_COLON }
| '='                  { KW_EQUAL }
| ','                  { KW_COMMA }
| "->"                 { KW_ARROW }
| "=="                 { KW_TST_EQUAL }
| ":="                 { KW_ASSIGN }
| id                   { ID (Lexing.lexeme lexbuf) }
| ['0'-'9']+ '.'       { MSG_LABEL (Lexing.lexeme lexbuf) }
| eof                  { KW_EOF }
| _                    { KW_CHAR (Lexing.lexeme lexbuf) }
