
type term = VAR of string
          | APP of string * term list
          | LINE of (int * int) * term;;

let rec term_out t = match t with
        (VAR s) -> print_string s
      | (APP (f, l)) -> (print_char '(';
			     print_string f;
			     print_char ' ';
			     term_list_out l;
			     print_char ')')
      | (LINE ((m,n), t)) -> (print_char '#';
				  print_int m;
				  print_char '-';
				  print_int n;
				  print_char ' ';
				  term_out t)
and term_list_out l = match l with
    [] -> ()
  | (t::l) -> (term_out t;
	       print_char ' ';
	       term_list_out l);;
